/* Exemplet visar några åtgärder som kan göras då man släpper på
   en drop zone. Dels gör man förändringar av elementet som man
   släppt på, dels gör man förändringar av det element som dragits. */
// --------------------------------------------------
// Globala variabler och konstanter

// --------------------------------------------------
// Initiering då webbsidan är inläst
function init() {
    let dragElems = document.querySelectorAll("#dragItems div");
    for (let i = 0; i < dragElems.length; i++) {
        dragElems[i].draggable = true;
        dragElems[i].addEventListener("dragstart", dragStart);
    }
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Hantera en drag-operation
function dragStart(e) {
    let dragElem = this; // Det element som dras
    //e.dataTransfer.setData("text", dragElem.innerHTML);
    let dropElems = document.querySelectorAll("#dropZones div"); // Array med "drop zones"
    dragElem.addEventListener("dragend", dragEnd);
    for (let i = 0; i < dropElems.length; i++) {
        dropElems[i].addEventListener("dragover", dropZone);
        dropElems[i].addEventListener("dragenter", dropZone);
        dropElems[i].addEventListener("dragleave", dropZone);
        dropElems[i].addEventListener("drop", dropZone);
    }
    // ----------
    // Avsluta drag-operationen
    function dragEnd(e) {
        dragElem.removeEventListener("dragend", dragEnd);
        for (let i = 0; i < dropElems.length; i++) {
            dropElems[i].removeEventListener("dragover", dropZone);
            dropElems[i].removeEventListener("dragenter", dropZone);
            dropElems[i].removeEventListener("dragleave", dropZone);
            dropElems[i].removeEventListener("drop", dropZone);
        }
    } // Slut dragEnd
    // ----------
    // Hantera händelser för drop zones
    function dropZone(e) {
        e.preventDefault();
        let dropElem = this; // Det element som man släppt på
        switch (e.type) {
            case "dragenter": // Visuell feedback
                dropElem.classList.add("hiliteDropZone");
                break;
            case "dragleave": // Ta bort visuell feedback
                dropElem.classList.remove("hiliteDropZone");
                break;
            case "drop":  // Gör vad som ska ske då man släpper på en drop zone
                dropElem.classList.remove("hiliteDropZone"); // Ta bort visuell feedback
                // dropElem.innerHTML = e.dataTransfer.getData("text");
                dropElem.innerHTML = dragElem.innerHTML; // Prova med +=
                //dragElem.style.display = "none";
                //dragElem.style.visibility = "hidden";
                //dragElem.innerHTML = "";
                dragElem.classList.add("taken");
                dragElem.draggable = false; // Elementet kan inte längre dras
        } // Slut switch
    } // Slut dropZone
    // ----------
} // Slut dragStart
// --------------------------------------------------
